package  {
  import com.adobe.serialization.json.JSON;
  import flash.display.Graphics;
  import flash.display.Shape;
  import flash.events.Event;
  import mx.collections.ArrayCollection;
  import mx.core.IMXMLObject;
  import mx.events.FlexEvent;
  import spark.components.DropDownList;
  
  public class ViewHelper implements IMXMLObject {
    private const HOST:String = 'localhost';
    private const ENTRY:String = '/cv/starkeypoints/';
    private var view:Main;
    private var client:HTTPClient;
    private var shape:Shape;
    private var imageList:ArrayCollection;
    
    public function initialized(document:Object, id:String):void {
      view = document as Main;
      view.addEventListener(FlexEvent.CREATION_COMPLETE, onCreationComplete);
    }
    private function onCreationComplete(e:FlexEvent):void {
      try {
        view.removeEventListener(FlexEvent.CREATION_COMPLETE, arguments.callee);
        client = new HTTPClient(HOST);
        shape = new Shape();
        view.Image.addChild(shape);
        imageList = new ArrayCollection([{'name':'Tiffany'}, {'name':'Couple'}]);
        var dl:DropDownList = view.ImageList;
        dl.dataProvider = imageList;
        dl.labelField = 'name';
        dl.selectedItem = imageList[0];
        dl.addEventListener(Event.CHANGE, onImageChange, false, 0, true);
        view.Button.addEventListener(FlexEvent.BUTTON_DOWN, perform, false, 0, true);
        onImageChange(new Event(Event.CHANGE));
        client.addEventListener(HTTPResponse.HTTP_OK,
          function():void {
            var data:Object = JSON.decode(client.response.body);
            plot(data);
          });
        client.addEventListener(HTTPResponse.HTTP_NOT_FOUND,
          function():void {
            view.InfoLabel.text = client.response.code + ' client error';
          });
        client.addEventListener(HTTPResponse.HTTP_SERVER_ERROR,
          function():void {
            view.InfoLabel.text = client.response.code + ' server error';
          });
      }catch(e:Error) {
        view.InfoLabel.text = e.message;  
      }
    }
    private function perform(e:FlexEvent):void {
      var name:String = view.ImageList.selectedItem.name.toLowerCase();
      var maxsize:uint = view.Stepper.value;
      client.perform(ENTRY + name + '/maxsize/' + maxsize);
    }
    private function plot(data:Object):void {
      view.Image.setChildIndex(shape, view.Image.numChildren - 1);
      view.InfoLabel.text = 'Numbers of Key Point: ' + data.keypoints.length;
      var g:Graphics = shape.graphics;
      g.clear();
      for(var i:String in data.keypoints) {
        var k:Object = data.keypoints[i];
        var r:uint = k.size/2;
        g.lineStyle(1, 0x0099ff);
        g.drawCircle(k.x, k.y, r);
        g.moveTo(k.x - r, k.y - r);
        g.lineTo(k.x + r, k.y + r);
        g.moveTo(k.x + r, k.y - r);
        g.lineTo(k.x - r, k.y + r);
      }
    }
    private function onImageChange(e:Event):void {
      var name:String = view.ImageList.selectedItem.name.toLowerCase();
      view.Image.source = 'assets/' + name + '.jpg';
    }
  }
}
